#!/usr/bin/env python3

import sys
import argparse
import dbus
import time
from gi.repository import GObject
from dbus.mainloop.glib import DBusGMainLoop

DBusGMainLoop(set_as_default=True)

parser = argparse.ArgumentParser(description='Testing tcmmd')
parser.add_argument('-S','--ipsrc', help='IP source',required=True)
parser.add_argument('-D','--ipdst', help='IP destination', required=True)
parser.add_argument('-s','--tcpsport', help='TCP source port',required=True)
parser.add_argument('-d','--tcpdport', required=True,
                    help='TCP destination port')
parser.add_argument('-B','--backgroundrate', required=True,
                    help='Background rate in B/s')
parser.add_argument('-P','--priorityrate', required=True,
                    help='Priority stream rate in B/s')
args = parser.parse_args()

bus = dbus.SystemBus()
remote_object = bus.get_object("org.tcmmd",
                               "/org/tcmmd/ManagedConnections")
iface = dbus.Interface(remote_object, "org.tcmmd.ManagedConnections")

#print("{0}:{1} -> {2}:{3}  -  stream: {4} B/s  background: {5} B/s".format(
#        str(args.ipsrc), int(args.tcpsport),
#        str(args.ipdst), int(args.tcpdport),
#        int(args.priorityrate), int(args.backgroundrate)))

# Do not expect a reply.
ret = iface.SetFixedPolicy(str(args.ipsrc), int(args.tcpsport),
                           str(args.ipdst), int(args.tcpdport),
                           int(args.priorityrate),
                           int(args.backgroundrate),
                           ignore_reply=True)

# Loop forever until killed by the test harness.
loop = GObject.MainLoop()
loop.run()
